﻿using mshtml;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;
using SHDocVw;
using System.Runtime.Serialization.Json;
using System.Web.Script.Serialization;
using System.Windows.Threading;

namespace IE
{
    public class J
    {
        public string H { get; set; }
        public string L { get; set; }
        public string O { get; set; }
        public string C { get; set; }
    }
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        DispatcherTimer DT = new DispatcherTimer();
        public MainWindow()
        {
            InitializeComponent();
            //Has("AAA", "***");
            DT.Interval = TimeSpan.FromMilliseconds(25);
            DT.Tick += DT_Tick;
         //  GetData();
          //  CreateFromTXT();
          //  now = alltext.Count() - 1;
        }

        private void DT_Tick(object sender, EventArgs e)
        {
            GetPoint(alltext[now]);
            now--;
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var bs = serializer.Serialize(N);
            ShowPanel.Document.InvokeScript("getdatafromday", new object[] { T, bs });
        }

        private string GetBaseHtml()
        {
            string basehtml = string.Empty;
            string name = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name + ".InWeb.html";
            Assembly assembly = System.Reflection.Assembly.GetExecutingAssembly();
            using (Stream stream = assembly.GetManifestResourceStream(name))
            {
                using (var js = new StreamReader(stream))
                {
                    basehtml = js.ReadToEnd();
                }
            }
            return basehtml;
        }
        private void ShowPanel_Loaded(object sender, RoutedEventArgs e)
        {

            ShowPanel.DocumentText = GetBaseHtml();

        }
        int now = 1;
        string[] alltext;
        private void CreateFromTXT()
        {


           // var path = $@"C:\Users\wppcn\Desktop\恒指期货期货历史数据.csv";
           // StreamReader stream = new StreamReader(path);
          //  var text = stream.ReadToEnd().Split(new char[] { '\r', '\n' });
            alltext =GetData().Split(new char[] { '\r', '\n' });
          //  stream.Dispose();
            
        }
        private  bool Has(string str1,string str2)
        {
            bool r=false;

            if (str2.Length > str1.Length)
                return r;
            if (str2.Where(x => x == '*').Count() == str2.Length)
                return true;


            return r;
        }
         string GetData()
        {
            string k = string.Empty;
            string name = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name + ".恒指期货期货历史数据.csv";
            Assembly assembly = System.Reflection.Assembly.GetExecutingAssembly();
            using (Stream stream = assembly.GetManifestResourceStream(name))
            {
                using (var data = new StreamReader(stream))
                {
                    k = data.ReadToEnd();
                }
            }
            return k;
        }
        private void A()
        {

            CreateFromTXT();
            now = alltext.Count() - 1;
            while (now >0)
            {
                GetPoint(alltext[now]);
                now--;
                
            }
          
          
        }
        List<J> N=new  List<J>();
        string T;
        private void GetPoint(string text)
        {

            var p = text.Replace("\"", "}").Replace(",", "");
            if (!string.IsNullOrWhiteSpace(p))
            {
                var b = p.Split(new char[] { '}' });
                T += $"{b[1]},\r\n";
                // $"[{b[5]},{b[3]},{b[9]},{b[7]}]"
                N.Add(new J() { O=b[5],C=b[3],H=b[9],L=b[7] });
            }
          
        }
        private void ShowPanel_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
          // DT.Start();
             A();
            //J f = new J();
            //  f.D = N;
          N.Reverse();
           JavaScriptSerializer serializer = new JavaScriptSerializer();
         var b=  serializer.Serialize (N);
          
             
           // var c = N;//;.Insert(0, "[").Insert(N.Length - 1, "]");
            var d = T.Insert(0, "").Insert(T.Length - 1, "");
          ShowPanel.Document.InvokeScript("getdatafromday", new object[] { d,b });

            ShowPanel.Document.InvokeScript("setheight", new object[] { $"{ShowPanel.Height }px" });
            ShowPanel.Document.InvokeScript("setwidth", new object[] { $"{ShowPanel.Width }px" });
            ShowPanel.SizeChanged += ShowPanel_SizeChanged;
        }



        private void ShowPanel_SizeChanged(object sender, EventArgs e)
        {
            if (ShowPanel != null)
            {
                ShowPanel.Document.InvokeScript("setheight", new object[] { $"{ShowPanel.Height - 50}px" });
                ShowPanel.Document.InvokeScript("setwidth", new object[] { $"{ShowPanel.Width - 50}px" });
            }
        }
    }
}
